<?php

add_shortcode('wp-video-contest-upload-video', 'wp_video_contest_upload_video');

function wp_video_contest_upload_video($atts, $content = null) {
	
  //Important variables 
  $user_ID = get_current_user_id();
  $html = '';//Inciate output string
  $koncovky = array('jpg', 'jpeg', 'png', 'gif');
   
  $number_videos = get_user_meta($user_ID, 'contest_user_videos', true);
  if(empty($number_videos)){$number_videos=0;}
  
  
  if( 'POST' == $_SERVER['REQUEST_METHOD'] && !empty( $_POST['action'] ) &&  $_POST['action'] == "new_post") {
    $error = array();
    // Do some minor form validation to make sure there is content
    if (empty($_POST['video-name'])){
        $error['name'] = __('Please enter a Caption!','wp-video-contest');
    } else {
        $name = trim($_POST['video-name']);  
    }
    
    //Check video
    if (empty($_POST['contest-video'])){
        $error['video'] = __('Please enter a video url!','wp-video-contest');
    } else {
    
        $video_url = trim($_POST['contest-video']);
if (    strrpos($video_url, "http://www.youtube.com") === false 
    AND strrpos($video_url, "http://youtube.com") === false 
    AND strrpos($video_url, "http://youtu.be") === false 
    AND strrpos($video_url, "http://www.youtu.be") === false 
    AND strrpos($video_url, "https://www.youtube.com") === false 
    AND strrpos($video_url, "https://youtube.com") === false 
    AND strrpos($video_url, "https://youtu.be") === false 
    AND strrpos($video_url, "https://www.youtu.be") === false 
    AND strrpos($video_url, "https://m.youtu.be") === false 
    AND strrpos($video_url, "https://m.youtube.com") === false 
    AND strrpos($video_url, "http://m.youtu.be") === false 
    AND strrpos($video_url, "http://m.youtube.com") === false){
        $error['video_url'] = __('Please enter a valid Youtube video url!','wp-video-contest');    
      }
    }
    if (empty($_POST['video-description'])){
       $description = ''; 
    } else {
       $description = $_POST['video-description'];  
    }
    
    if(empty($error)){
    //If no exist error - create attachment post
    
    /**
     * Create new post
     */         
    $args = array(
      'post_title'      => $name,
      'post_content'    => $description,
      'post_type'       => 'wp_video_contest',
      'post_status'     => 'publish'
    );
    
    /**
     * Get new post id
     */         
    $post_id = wp_insert_post($args);
    
    /**
     * Get video id from url
     */         
    //$video_id = wp_video_contest_parse_youtube_id($video_url);
    $video_id = wp_video_contest_get_video_id($video_url);
    
    /**
     * Update post meta
     */         
    $activate = get_option('video-pcplugin-allow-activate');
	if($activate =='2'){
    update_post_meta($post_id,'contest-active',0);
    }else
	{
    update_post_meta($post_id,'contest-active',1);
    }
    update_post_meta($post_id,'contest-video-points',0);
    update_post_meta($post_id,'contest-video-author',$user_ID);
    
    update_post_meta($post_id,'video_id',$video_id);
    
    /**
     * Increase images number for current author
     */         
    $number_videos = $number_videos+1;
    update_user_meta($user_ID, 'contest_user_videos', $number_videos);
    
  
		$current_url = get_permalink();

    $redirect_url = add_query_arg( array('contest' => 'upload-video','thank-you' => 'ok'), $current_url );
     
    wp_redirect($redirect_url);
    
    }

 } 
  
  $html .= '<div class="video_clear"></div>';
   $start = get_option('video-pcplugin-contest-start');
   $end = get_option('video-pcplugin-contest-end');
   $regends = get_option('video-pcplugin-contest-reg-ends');
   $date = StrFTime('%m/%d/%Y', Time());
   
   
   $today_time = strtotime($date);
   $begin_time = strtotime($start); 
   $expire_time = strtotime($end);
   $registration_time = strtotime($regends);
   
   $source = $regends;
  $daten = new DateTime($source);
  $dates = new DateTime($start);
   
   if(empty($user_ID)){
	  if($expire_time < $today_time){
  
           $html .= '<div class="wp_video_contest-info-bar"><i class="fa fa-exclamation-circle"></i> '.__('Competition already finished.','wp-video-contest').'</div>';
  
        }else{
	 
	 
    //User id is empty - user is not logged
	if (isset($_GET['action'])) {
	 if ($_GET['action']=='register') {		
	    $html .= '';	
	 }
	}else{	
	
	    $html .= '<div class="wp_video_contest-info-bar"><i class="fa fa-exclamation-triangle"></i> '.__('You must be logged for upload video.','wp-video-contest').' <a href="'.$_SERVER['REQUEST_URI'].'&action=register">'.__('Register','wp-video-contest').'</a></div><div class="video_clear"></div>';
	
	 }
	 if (isset($_GET['action'])) {
	 if ($_GET['action']=='register_ok') {		
	    $html .= '<div class="wp_video_contest-info-bar"><i class="fa fa-info"></i> '.__('Registration complete. Please check your e-mail.').'</div><div class="clear"></div>';	
		$html .= '<div class="wp_video_contest-upload-form-box">';
		$html .= ''.wp_video_login_and_sigin_form().'</div>';
	 }
	}
    
	//Login Form
	$html .= '<div class="wp_video_contest-upload-form-box">';
	
	//This line is only for testing
	//$html .= '<div class="contest-small-font contest-red-color">'.__('It is only a demo! Click to login button! ','wp-video-contest').'</div>';
	if(function_exists( 'wsl_render_auth_widget' ) ){
	  $pc_sociallogin = wsl_render_auth_widget();
    }else{  
	  $pc_sociallogin = "";
    }
	
	if (isset($_GET['action'])) {
	 if ($_GET['action']=='register') {		
	   $html .= ''.wp_video_contest_registration_form().''.$pc_sociallogin.'</div>';	
	 }
	}else {
	   $html .= ''.wp_video_login_and_sigin_form().''.$pc_sociallogin.'</div>';	
	 }
	
	    }
  
  }else{ 
  
  
   
   if($begin_time < $today_time){

   
   if($expire_time < $today_time){
  
    $html .= '<div class="wp_video_contest-info-bar"><i class="fa fa-exclamation-circle"></i> '.__('Competition already finished.','wp-video-contest').'</div>';
  
   }else{
	   if($registration_time < $today_time){
		   $date_format = get_option( 'video-pcplugin-date-format', true );
		   $html .= '<div class="wp_video_contest-info-bar"><i class="fa fa-exclamation-triangle"></i> '.__('Ability to enter the contest has expired to date','wp-video-contest').' '.$daten->format($date_format).'</div>';
		   
		   }else{ 
  $nmb_img = get_option( 'video-pcplugin-video-number', true );
  
	if(isset($_GET['thank-you'])){
    $html .= '<div class="wp_video_contest-info-bar-green"><i class="fa fa-check-circle"></i> '.__('Thank you for upload.','wp-video-contest').'</div>';
  }
  
  $html .= '<div class="wp_video_contest-upload-form-box">';
  $html .= '<div class="wp_video_contest-small-font">'.__('You can upload max.','wp-video-contest').' '.$nmb_img.' '.__('video(s).','wp-video-contest').'</div>';
  $html .= '<div class="wp_video_contest-small-font">'.__('You have already uploaded','wp-video-contest').' '.$number_videos.' '.__('video(s).','wp-video-contest').'</div>';
  
  if(($nmb_img - $number_videos)<1){
  $html .= '<div class="wp_video_contest-small-font">'.__('Thank you for your videos.','wp-video-contest').'</div>';
  }else{
  $html .= '<form id="new-post" action="" method="post">';
  $html .= '<fieldset>';
  
  
  if(!empty($error)){
    foreach($error as $item){
      $html .= '<div class="wp_video_contest-small-font contest-red-color">'.$item.'</div>';
    }
  }
  
  if(isset($_POST['video-name'])){$video_name = $_POST['video-name'];}
  if(isset($_POST['video-title'])){$video_title = $_POST['video-title'];}
  if(isset($_POST['video-description'])){$video_description = $_POST['video-description'];}
  

  $html .= '<div><label for="video-name"><strong>'.__('Caption:','wp-video-contest').'</strong></label></div>';
  $html .= '<div class="wp_video_contest-input"><input type="text" name="video-name" id="video-name" /></div>';
  $html .= '<div><label for="video-content"><strong>'.__('Description:','wp-video-contest').'</strong> <span class="wp_video_contest-small-font-2">'.__('(Optional)','wp-video-contest').'</span></label></div>';
  $html .= '<div class="wp_video_contest-input"><textarea class="video_video-description-textarea" name="video-description" id="video-description"></textarea></div>';
  $html .= '<div><label for="contest-video"><strong>'.__('Youtube Video URL:','video-content').'</strong></label></div>';
  $html .= '<div class="wp_video_contest-input"><input type="text" name="contest-video" id="contest-video" placeholder="Enter Youtube Video URL"/></div>';
  $html .= '<input type="hidden" name="user_id" />';
  $html .= '<input type="hidden" name="action" value="new_post" />';
  $html .= '<div class="wp_video_contest-button"><input type="submit" value="'.__('Add Video','video-content').'" id="submit" name="submit" /></div>';
  $html .= '</fieldset>';
  $html .= '</form>';
  $html .= '</div>';
	
  
  
  }	
  }
  
 }
 }else{
  $html .= ''.__('The contest has not yet started. It will launch on:','video-content').' '.$start;
  
    } 
}


//End control user login  
  
	return $html;
}

?>