<?php

add_shortcode('wp-video-contest-videos', 'wp_video_contest_videos');

function wp_video_contest_videos($atts, $content = null){

  $columns_number = get_option( 'video-pcplugin-columns-number' );
  $lines_number = get_option( 'video-pcplugin-lines-number' );
  
  $post_per_page = $columns_number*$lines_number;
  
  
  $html = '';
  
  
  global $paged;
  $paged = get_query_var( 'page' ) ? get_query_var( 'page' ) : get_query_var( 'paged' );
  
  if(isset($_GET['gallery-order'])){
    $atts['gallery-order'] = $_GET['gallery-order'];  
  }
  
  if(empty($atts['gallery-order'])){
  
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'DESC',
        'paged' => $paged 
        );
  
  }else{
  if($atts['gallery-order']=='date-down'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'DESC',
        'paged' => $paged 
        );
  }elseif($atts['gallery-order']=='date-up'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'ASC',
        'paged' => $paged 
        );
  }elseif($atts['gallery-order']=='points-down'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'DESC',
        'paged' => $paged 
        );  
  }elseif($atts['gallery-order']=='points-up'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'ASC',
        'paged' => $paged 
        );
  }
  
  
  
  }
  
   //Total images = 0
   $total_querys = get_posts($args);
   $immages = count($total_querys);
   $condition = get_option( 'video-pcplugin-condition' );
   $contestrules = stripslashes($condition);
   
   if($immages == 0){
	   
	   $html .= '<div class="video_clear"></div><div class="wp_video_contest-rules">'.$contestrules.'';
	   $html .= '<div class="wp_video_contest-small-font">'.__('No video has been submitted for the contest. Be the first','wp-video-contest').'</div>';
	   $html .= '</div>';
	   
	   }
	else   {
   $html .= '<div class="video_clear"></div>';
   $html .= '<div class="video_order-list">';
   $html .= '<form method="get" action="'.get_permalink().'" id="order-by-form">';
   if(isset($_GET['page_id'])){ 
   $html .= '<input type="hidden" name="page_id" value="'.$_GET['page_id'].'" />';
    }
   $html .= '<select name="gallery-order" id="gallery-order">';
   $html .= '<option value="date-down"';
    if(isset($_GET['gallery-order']) && $_GET['gallery-order'] == 'date-down'){
      $html .= ' selected="selected" '; 
    }
   $html .= '>'.__('Newest','wp-video-contest').'</option>';
   $html .= '<option value="date-up" ';
    if(isset($_GET['gallery-order']) && $_GET['gallery-order'] == 'date-up'){
      $html .= ' selected="selected" '; 
    }
   $html .= '>'.__('Oldest','wp-video-contest').'</option>';
   $html .= '<option value="points-down" ';
    if(isset($_GET['gallery-order']) && $_GET['gallery-order'] == 'points-down'){
      $html .= ' selected="selected" '; 
    }
   $html .= '>'.__('Most voted','wp-video-contest').'</option>';
   $html .= '<option value="points-up" ';
    if(isset($_GET['gallery-order']) && $_GET['gallery-order'] == 'points-up'){
      $html .= ' selected="selected" '; 
    }
   $html .= '>'.__('Least votes','wp-video-contest').'</option>';
   $html .= '</select>';
   $html .= '</form>';
   $html .= '</div><div class="video_clear"></div>';
   }
	  
   $html .= '<div class="video_gallery-wrap">';
   
   

   
$attachments = get_posts( $args );
if ( $attachments ) {
	foreach ( $attachments as $post ) {
		
        
        $video_active = get_post_meta($post->ID,'contest-active',true);
        $video_points = get_post_meta($post->ID,'contest-video-points',true);
        $video_id = get_post_meta($post->ID,'video_id',true);
        
        $current_url = get_permalink();
        $blogurl = add_query_arg( array('contest' => 'video-detail','video_id' => $post->ID), $current_url );
        
        
        $columns_number = get_option( 'video-pcplugin-columns-number' );
        $thumb_size = get_option( 'video-pcplugin-thumb-size' );
   if($video_active!=0){
	   
   $author_id = get_post_meta($post->ID,'contest-video-author',true);
   $title = mb_strimwidth($post->post_title, 0, 30, "...");
   $user = get_user_by( 'id', $author_id );
   $author = $user->nickname;
  
   //$line = $fileParts['dirname'].'/'.$fileParts['filename'];
   $line = 'http://img.youtube.com/vi/'.$video_id.'/0.jpg';
   $votes = get_post_meta($post->ID,'contest-video-points',true);
   
   if($columns_number==1){
   $html .= '<div class="one-full zip">';
   $html .= '<div class="video_video-container"><iframe src="http://www.youtube.com/embed/'.$video_id.'" 
frameborder="0" allowfullscreen></iframe></div>';
   $html .= '<div class="clear"></div><div class="gallery-title-autor"><div class="icon"><i class="fa fa-user"></i></div><div class="author">'.$author.'</div><br><div class="title">'.$title.'</div><div class="clear"></div></div>';
   $html .= '<div class="clear"></div><div class="video_gallery-votes"><span><i class="fa fa-heart"></i>&nbsp;&nbsp;<span>'.$votes.'</span></span><span><i class="fa fa-eye"></i>&nbsp;&nbsp;<span>'.getVCompetitionViews($post->ID).'</span></span><span class="right" onclick="location.href=\''.$blogurl.'\'"><i class="fa fa-video-camera"></i></span><div class="clear"></div></div>';
   $html .= '</div>';
   }elseif($columns_number==2){
	   $author2 = mb_strimwidth($author, 0, 30, "...");
	   $title = mb_strimwidth($post->post_title, 0, 50, "...");
   $html .= '<div class="one-half pop">';
   $html .= '<a data-test="small" href="'.$blogurl.'"><img src="'.$line.'" /></a>';
   $html .= '<div class="clear"></div><div class="gallery-title-autor"><div class="icon"><i class="fa fa-user"></i></div><div class="author">'.$author2.'</div><br><div class="title">'.$title.'</div><div class="clear"></div></div>';
   $html .= '<div class="clear"></div><div class="video_gallery-votes"><span><i class="fa fa-heart"></i>&nbsp;&nbsp;<span>'.$votes.'</span></span><span><i class="fa fa-eye"></i>&nbsp;&nbsp;<span>'.getVCompetitionViews($post->ID).'</span></span><span class="right" onclick="location.href=\''.$blogurl.'\'"><i class="fa fa-video-camera"></i></span><div class="clear"></div></div>';
   $html .= '</div>';
   }elseif($columns_number==3){
	   $author2 = mb_strimwidth($author, 0, 20, "...");
	   $title = mb_strimwidth($post->post_title, 0, 30, "...");
   $html .= '<div class="one-third pop">';
   $html .= '<a data-test="middle" href="'.$blogurl.'"><img src="'.$line.'" /></a>';
   $html .= '<div class="clear"></div><div class="gallery-title-autor"><div class="icon"><i class="fa fa-user"></i></div><div class="author">'.$author2.'</div><br><div class="title">'.$title.'</div><div class="clear"></div></div>';
   $html .= '<div class="clear"></div><div class="video_gallery-votes"><span><i class="fa fa-heart"></i>&nbsp;&nbsp;<span>'.$votes.'</span></span><span><i class="fa fa-eye"></i>&nbsp;&nbsp;<span>'.getVCompetitionViews($post->ID).'</span></span><span class="right" onclick="location.href=\''.$blogurl.'\'"><i class="fa fa-video-camera"></i></span><div class="clear"></div></div>';
   $html .= '</div>';
   }elseif($columns_number==4){
	   $author2 = mb_strimwidth($author, 0, 20, "...");
	   $title = mb_strimwidth($post->post_title, 0, 30, "...");
   $html .= '<div class="one-fourth pop">';
   $html .= '<a data-test="small" href="'.$blogurl.'"><img src="'.$line.'" /></a>';
   $html .= '<div class="clear"></div><div class="gallery-title-autor"><div class="icon"><i class="fa fa-user"></i></div><div class="author">'.$author2.'</div><br><div class="title">'.$title.'</div><div class="clear"></div></div>';
   $html .= '<div class="clear"></div><div class="video_gallery-votes"><span><i class="fa fa-heart"></i>&nbsp;&nbsp;<span>'.$votes.'</span></span><span><i class="fa fa-eye"></i>&nbsp;&nbsp;<span>'.getVCompetitionViews($post->ID).'</span></span><span class="right" onclick="location.href=\''.$blogurl.'\'"><i class="fa fa-video-camera"></i></span><div class="clear"></div></div>';
   $html .= '</div>';
   }elseif($columns_number==5){
	   $author2 = mb_strimwidth($author, 0, 15, "...");
	   $title = mb_strimwidth($post->post_title, 0, 20, "...");
   $html .= '<div class="one-fifth pop">';
   $html .= '<a data-test="small" href="'.$blogurl.'"><img src="'.$line.'" /></a>';
   $html .= '<div class="clear"></div><div class="gallery-title-autor"><div class="icon"><i class="fa fa-user"></i></div><div class="author">'.$author2.'</div><br><div class="title">'.$title.'</div><div class="clear"></div></div>';
   $html .= '<div class="clear"></div><div class="video_gallery-votes"><span><i class="fa fa-heart"></i>&nbsp;&nbsp;<span>'.$votes.'</span></span><span><i class="fa fa-eye"></i>&nbsp;&nbsp;<span>'.getVCompetitionViews($post->ID).'</span></span><span class="right" onclick="location.href=\''.$blogurl.'\'"><i class="fa fa-video-camera"></i></span><div class="clear"></div></div>';
   $html .= '</div>';
   }
   
   $html .= '';

    }
  }
}

   $html .= '</div>';      
    
    //Gallery paggination
    $range = 2;
    $showitems = ($range * 2)+1;
    $arguments = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => -1, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'       => '1',
        'paged' => $paged 
        ); 
    $total_query = get_posts( $arguments );
    
    $pages = count($total_query);
    global $paged;
    if(empty($paged)) $paged = 1;
    $pages = ceil($pages / $post_per_page);
      if($pages != 1){
        $html .= '<div class="video_clear"></div><div class="wp_video_contest-pagination">';
      if($paged > 2 && $paged > $range+1 && $showitems < $pages) 
        $html .= '<a href="'.get_pagenum_link(1).'">'.__("First","wp-video-contest").'</a>';
      if($paged > 1 && $showitems < $pages) 
        $html .= "<a href='".get_pagenum_link($paged - 1)."'>".__('Last','wp-video-contest')."</a>";
         
        for ($i=1; $i <= $pages; $i++){
          if (1 != $pages &&( !($i >= $paged+$range || $i <= $paged-$range) || $pages <= $showitems )){
            $html .= ($paged == $i)? "<span class='current'>".$i."</span>":"<span class='inactive'><a href='".get_pagenum_link($i)."'>".$i."</a></span>";
          }
        }
        if ($paged < $pages && $showitems < $pages) 
          $html .= "<a href='".get_pagenum_link($paged + 1)."'>".__('Next','wp-video-contest')."</a>";  
        if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) 
          $html .= "<a href='".get_pagenum_link($pages)."'>".__('Last','wp-video-contest')."</a>";
          $html .= "</div>";
     }
     
      return $html;

}


?>
