<?php

// Add function to widgets_init that'll load our widget
add_action( 'widgets_init', 'mm_wp_videocontest_widgets' );

// Register widget
function mm_wp_videocontest_widgets() {
	register_widget( 'mm_WP_Videocontest_Widget' );
	register_widget( 'mm_WP_Videocontest_Widget_Gallery' );
	register_widget( 'mm_WP_Videocontest_Widget_Rank' );
}

// Widget class
class mm_wp_videocontest_widget extends WP_Widget {


/*-----------------------------------------------------------------------------------*/
/*	Widget Construct
/*-----------------------------------------------------------------------------------*/
	
public function mm_WP_Videocontest_Widget() {

	// Widget settings
	$widget_ops = array(
		'classname' => 'mm_wp_videocontest_widget',
		'description' => __('Widget displays videos from wp video contest.', 'wp-video-contest')
	);

	// Widget control settings
	$control_ops = array(
		'width' => 280,
		'height' => 350,
		'id_base' => 'mm_wp_videocontest_widget'
	);

	/* Create the widget. */
	$this->WP_Widget( 'mm_wp_videocontest_widget', __('WP Video Contest Widget', 'wp-video-contest'), $widget_ops, $control_ops );
	
}


/*-----------------------------------------------------------------------------------*/
/*	Display Widget
/*-----------------------------------------------------------------------------------*/
	
public function widget( $args, $instance ) {
	extract( $args );
	// Our variables from the widget settings
	$title = apply_filters('widget_title', $instance['title'] );
	$order = $instance['order'];
  $page_id = $instance['page_id'];
  $post_per_page = $instance['per_page'];
  
	// Before widget (defined by theme functions file)
	echo $before_widget;
  

	// Display the widget title if one was input
  if ( $title )
		echo $before_title . $title . $after_title;

// Display widget
  

if(empty($order)){
  
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'DESC'
        );
  
  }else{
  if($order=='date-down'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'DESC'
        );
  }elseif($order=='date-up'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'ASC'
        );
  }elseif($order=='points-down'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'DESC'
        );  
  }elseif($order=='points-up'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'ASC'
        );
  }elseif($order=='rand'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'rand',
	      'order'          => 'ASC'
        );
  }
}
?>
    <div id="video-wrap" class="video-wrap">
<?php 

$attachments = get_posts( $args );
if ( $attachments ) {
	foreach ( $attachments as $post ) {
		
        
        $video_active = get_post_meta($post->ID,'contest-active',true);
        $video_points = get_post_meta($post->ID,'contest-video-points',true);
		$video_id = get_post_meta($post->ID,'video_id',true);
         
        
   if($video_active!=0){
   $link = get_permalink($page_id);
   $blogurl = add_query_arg( array('contest' => 'video-detail','video_id' => $post->ID), $link );
    
  
   $line = 'http://img.youtube.com/vi/'.$video_id.'/0.jpg';
   
   ?>
   <div class="video_widget-contest-classic-div"><a data-test="full" class="video-thumb" href="<?php echo $blogurl; ?>"><img style="width:100%;" src="<?php echo $line; ?>" /></a></div>
   <?php
    }
  }
}

?>    
    
    
    </div>      
    <div class="video_clear"></div>
<?php    	
  //Display define after widget
	echo $after_widget;

}

/*-----------------------------------------------------------------------------------*/
/*	Update Widget
/*-----------------------------------------------------------------------------------*/
	
	public function update( $new_instance, $old_instance ) {
  
		$instance = $old_instance;
    $instance['title']    = strip_tags( $new_instance['title'] );
    $instance['order']    = $new_instance['order'];
    $instance['page_id']  = $new_instance['page_id'];
    $instance['per_page'] = $new_instance['per_page'];
  	return $instance;
	}


/*-----------------------------------------------------------------------------------*/
/*	Widget Settings (Displays the widget settings controls on the widget panel)
/*-----------------------------------------------------------------------------------*/

	public function form( $instance ) {
	$title = isset($instance['title']) ? esc_attr($instance['title']) : 'WP Video Contest';
	if (empty($instance['order'])) {
       $order = "";
     }else{
       $order = $instance['order'];
    }
	if (empty($instance['page_id'])) {
       $page_id = "";
     }else{
       $page_id = $instance['page_id'];
     }
  $per_page = isset($instance['per_page']) ? absint($instance['per_page']) : '5';  

  $order_array = array(
      'date-down'   => __('Newest', 'wp-video-contest'),
      'date-up'     => __('Oldest', 'wp-video-contest'),
      'points-down' => __('Most Voted', 'wp-video-contest'),
      'points-up'   => __('Least Votes', 'wp-video-contest'),
      'rand'   => __('Random Videos', 'wp-video-contest')
  );
  $per_page_array = array(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20);
  
    ?>
    <p>
	  <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'wp-video-contest') ?></label>
      <input class="widefat" type="text" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $title; ?>">
    </p>
    
    <p>	
      <label for="<?php echo $this->get_field_id( 'order' ); ?>"><?php _e('Sort By:', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'order' ); ?>" name="<?php echo $this->get_field_name( 'order' ); ?>">
         <?php
         foreach( $order_array as $key => $item ){ ?>
			   <option <?php if($order == $key){ echo 'selected="selected"'; } ?> value="<?php echo $key; ?>"><?php echo $item; ?></option>
        <?php } ?>
      </select>
	</p>
    
    <p>
	  <label for="<?php echo $this->get_field_id( 'per_page' ); ?>"><?php _e('Number of Videos', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'per_page' ); ?>" name="<?php echo $this->get_field_name( 'per_page' ); ?>">
         <?php
         foreach( $per_page_array as $item ){ ?>
			   <option <?php if($item == $per_page){ echo 'selected="selected"'; } ?> value="<?php echo $item; ?>"><?php echo $item; ?></option>
        <?php } ?>
      </select>
	</p>
    
    <p>
	  <label for="<?php echo $this->get_field_id( 'page_id' ); ?>"><?php _e('Select Competition Page', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'page_id' ); ?>" name="<?php echo $this->get_field_name( 'page_id' ); ?>">
         <?php
         $args = array(
                   'post_type' => 'page',
	                 'post_status' => 'publish'
         );
         $pages = get_pages( $args );
         foreach( $pages as $item ){ ?>
			   <option <?php if($item->ID == $page_id){ echo 'selected="selected"'; } ?> value="<?php echo $item->ID; ?>"><?php echo $item->post_title; ?></option>
        <?php } ?>
      </select>
		</p>
    
	<?php
	}


	 
}//End class

class mm_wp_videocontest_widget_gallery extends WP_Widget {


/*-----------------------------------------------------------------------------------*/
/*	Widget Construct
/*-----------------------------------------------------------------------------------*/
	
public function mm_WP_Videocontest_Widget_Gallery() {

	// Widget settings
	$widget_ops = array(
		'classname' => 'mm_wp_videocontest_widget_gallery',
		'description' => __('Widget displays videos from wp video contest.', 'wp-video-contest')
	);

	// Widget control settings
	$control_ops = array(
		'width' => 280,
		'height' => 350,
		'id_base' => 'mm_wp_videocontest_widget_gallery'
	);

	/* Create the widget. */
	$this->WP_Widget( 'mm_wp_videocontest_widget_gallery', __('WP Video Contest Widget - Gallery', 'wp-video-contest'), $widget_ops, $control_ops );
	
}


/*-----------------------------------------------------------------------------------*/
/*	Display Widget
/*-----------------------------------------------------------------------------------*/
	
public function widget( $args, $instance ) {
	extract( $args );
	// Our variables from the widget settings
	$title = apply_filters('widget_title', $instance['title'] );
	$order = $instance['order'];
  $page_id = $instance['page_id'];
  $post_per_page = $instance['per_page'];
  
	// Before widget (defined by theme functions file)
	echo $before_widget;
  

	// Display the widget title if one was input
  if ( $title )
		echo $before_title . $title . $after_title;

// Display widget
  

if(empty($order)){
  
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'DESC'
        );
  
  }else{
  if($order=='date-down'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'DESC'
        );
  }elseif($order=='date-up'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_key'       => 'contest-active',
        'meta_value'     => '1',
        'orderby'        => 'post_date',
	      'order'          => 'ASC'
        );
  }elseif($order=='points-down'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'DESC'
        );  
  }elseif($order=='points-up'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'ASC'
        );
  }elseif($order=='rand'){
  $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'rand',
	      'order'          => 'ASC'
        );
  }
}
?>
    <div id="video-wrap" class="video-wrap">
<?php 

$attachments = get_posts( $args );
if ( $attachments ) {
	foreach ( $attachments as $post ) {
		
        
        $video_active = get_post_meta($post->ID,'contest-active',true);
        $video_points = get_post_meta($post->ID,'contest-video-points',true);
		$video_id = get_post_meta($post->ID,'video_id',true);
        $blogurl = home_url('url');
        
   if($video_active!=0){
   $link = get_permalink($page_id);
   $blogurl = add_query_arg( array('contest' => 'video-detail','video_id' => $post->ID), $link );
    
  
   $line = 'http://img.youtube.com/vi/'.$video_id.'/1.jpg';
   ?>
   <div class="video_widget-contest-gallery-div"><a data-test="full" class="video_widget-photo-thumb" href="<?php echo $blogurl; ?>"><img class="video_widget-contest-gallery-img" src="<?php echo $line; ?>" /></a></div>
   <?php
    }
  }
}

?>    
    
    
    </div>      
    <div class="video_clear"></div>
<?php    	
  //Display define after widget
	echo $after_widget;

}

/*-----------------------------------------------------------------------------------*/
/*	Update Widget
/*-----------------------------------------------------------------------------------*/
	
	public function update( $new_instance, $old_instance ) {
  
		$instance = $old_instance;
    $instance['title']    = strip_tags( $new_instance['title'] );
    $instance['order']    = $new_instance['order'];
    $instance['page_id']  = $new_instance['page_id'];
    $instance['per_page'] = $new_instance['per_page'];
  	return $instance;
	}


/*-----------------------------------------------------------------------------------*/
/*	Widget Settings (Displays the widget settings controls on the widget panel)
/*-----------------------------------------------------------------------------------*/

	public function form( $instance ) {
	$title = isset($instance['title']) ? esc_attr($instance['title']) : 'WP Video Contest';
	
	if (empty($instance['order'])) {
       $order = "";
     }else{
       $order = $instance['order'];
    }
	if (empty($instance['page_id'])) {
       $page_id = "";
     }else{
       $page_id = $instance['page_id'];
     }
	 
	 
  $per_page = isset($instance['per_page']) ? absint($instance['per_page']) : '5';  

  $order_array = array(
      'date-down'   => __('Newest', 'wp-video-contest'),
      'date-up'     => __('Oldest', 'wp-video-contest'),
      'points-down' => __('Most Voted', 'wp-video-contest'),
      'points-up'   => __('Least Votes', 'wp-video-contest'),
      'rand'   => __('Random Videos', 'wp-video-contest')
  );
  $per_page_array = array(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,30,40,50);
  
    ?>
    <p>
	  <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'wp-video-contest') ?></label>
      <input class="widefat" type="text" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $title; ?>">
    </p>
    
    <p>	
      <label for="<?php echo $this->get_field_id( 'order' ); ?>"><?php _e('Sort By:', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'order' ); ?>" name="<?php echo $this->get_field_name( 'order' ); ?>">
         <?php
         foreach( $order_array as $key => $item ){ ?>
			   <option <?php if($order == $key){ echo 'selected="selected"'; } ?> value="<?php echo $key; ?>"><?php echo $item; ?></option>
        <?php } ?>
      </select>
	</p>
    
    <p>
	  <label for="<?php echo $this->get_field_id( 'per_page' ); ?>"><?php _e('Number of Videos', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'per_page' ); ?>" name="<?php echo $this->get_field_name( 'per_page' ); ?>">
         <?php
         foreach( $per_page_array as $item ){ ?>
			   <option <?php if($item == $per_page){ echo 'selected="selected"'; } ?> value="<?php echo $item; ?>"><?php echo $item; ?></option>
        <?php } ?>
      </select>
	</p>
    
    <p>
	  <label for="<?php echo $this->get_field_id( 'page_id' ); ?>"><?php _e('Select Competition Page', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'page_id' ); ?>" name="<?php echo $this->get_field_name( 'page_id' ); ?>">
         <?php
         $args = array(
                   'post_type' => 'page',
	                 'post_status' => 'publish'
         );
         $pages = get_pages( $args );
         foreach( $pages as $item ){ ?>
			   <option <?php if($item->ID == $page_id){ echo 'selected="selected"'; } ?> value="<?php echo $item->ID; ?>"><?php echo $item->post_title; ?></option>
        <?php } ?>
      </select>
		</p>
    
	<?php
	}


	 
}//End class


class mm_wp_videocontest_widget_rank extends WP_Widget {


/*-----------------------------------------------------------------------------------*/
/*	Widget Construct
/*-----------------------------------------------------------------------------------*/
	
public function mm_WP_Videocontest_Widget_Rank() {

	// Widget settings
	$widget_ops = array(
		'classname' => 'mm_wp_videocontest_widget_rank',
		'description' => __('Widget displays rank from wp video contest.', 'wp-video-contest')
	);

	// Widget control settings
	$control_ops = array(
		'width' => 280,
		'height' => 350,
		'id_base' => 'mm_wp_videocontest_widget_rank'
	);

	/* Create the widget. */
	$this->WP_Widget( 'mm_wp_videocontest_widget_rank', __('WP Video Contest Widget - Rank', 'wp-video-contest'), $widget_ops, $control_ops );
	
}


/*-----------------------------------------------------------------------------------*/
/*	Display Widget
/*-----------------------------------------------------------------------------------*/
	
public function widget( $args, $instance ) {
	extract( $args );
	// Our variables from the widget settings
	$title = apply_filters('widget_title', $instance['title'] );
  $page_id = $instance['page_id'];
  $post_per_page = $instance['per_page'];
  
	// Before widget (defined by theme functions file)
	echo $before_widget;
  

	// Display the widget title if one was input
  if ( $title )
		echo $before_title . $title . $after_title;

// Display widget
  

      $args = array( 
        'post_type'      => 'wp_video_contest', 
        'posts_per_page' => $post_per_page, 
        'post_status'    => 'any', 
        'post_parent'    => null,
        'meta_query' => array(
      array(
         'key'     => 'contest-active',
         'value'   => '1')
      ),
        'meta_key'       => 'contest-video-points',
        'orderby'        => 'meta_value_num',
	      'order'          => 'DESC'
        ); 
?>
    <div id="photo-wrap" class="photo-wrap">
<?php 
   
$i = 0;
$attachments = get_posts( $args );
if ( $attachments ) {
	foreach ( $attachments as $post ) {
		
        
        $video_active = get_post_meta($post->ID,'contest-active',true);
        $video_points = get_post_meta($post->ID,'contest-video-points',true);
        $blogurl = home_url('url');
        
   if($video_active!=0){
   
  
   
   $link = get_permalink($page_id);
   $new_query = add_query_arg( array('contest' => 'video-detail' , 'video_id' => $post->ID), $link );
   $i++;
   $author_id = get_post_meta($post->ID,'contest-video-author',true);
   $user = get_user_by( 'id', $author_id );
   $author = $user->nickname;
   $author2 = $user->nickname;
   $author = (strlen($author) > 15) ? substr($author,0,18).'...': $author;
   $title = $post->post_title;
   $title2 = $post->post_title;
   $title = (strlen($title) > 22) ? substr($title,0,25).'...': $title;
   
   ?>
   <div class="video_widget-contest-rank">
     <div class="video_widget-contest-rank-num" >
        <div class="video_widget-contest-rank-pos" ><a href="<?php echo $new_query; ?>"><?php echo $i ?></a></div>
     </div>   
   <div class="video_widget-contest-rank-info">
       <div title="<?php echo $author2; ?>"><span><a href="<?php echo $new_query; ?>"><?php echo $author; ?></a></span></div>
       <div title="<?php echo $title2; ?>"><?php echo $title; ?></div>
       <div class="video_widget-contest-votes">Votes: <?php echo $video_points; ?></div>
   </div>
   
   
   <div class="video_clear"></div>
   </div>
   <div class="video_clear"></div>
   <?php
    
    }
  }
}

?>    
    
    
    </div>      
    <div class="video_clear"></div>
<?php    	
  //Display define after widget
	echo $after_widget;

}

/*-----------------------------------------------------------------------------------*/
/*	Update Widget
/*-----------------------------------------------------------------------------------*/
	
	public function update( $new_instance, $old_instance ) {
  
		$instance = $old_instance;
    $instance['title']    = strip_tags( $new_instance['title'] );
    $instance['page_id']  = $new_instance['page_id'];
    $instance['per_page'] = $new_instance['per_page'];
  	return $instance;
	}


/*-----------------------------------------------------------------------------------*/
/*	Widget Settings (Displays the widget settings controls on the widget panel)
/*-----------------------------------------------------------------------------------*/

	public function form( $instance ) {
	$title = isset($instance['title']) ? esc_attr($instance['title']) : 'WP Video Contest';
    if (empty($instance['page_id'])) {
       $page_id = "";
     }else{
       $page_id = $instance['page_id'];
     }
  $per_page = isset($instance['per_page']) ? absint($instance['per_page']) : '5';  

  
  $per_page_array = array(1,2,3,4,5);
  
    ?>
    <p>
	  <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'wp-video-contest') ?></label>
      <input class="widefat" type="text" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $title; ?>">
    </p>
    
   
    
    <p>
	  <label for="<?php echo $this->get_field_id( 'per_page' ); ?>"><?php _e('Items', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'per_page' ); ?>" name="<?php echo $this->get_field_name( 'per_page' ); ?>">
         <?php
         foreach( $per_page_array as $item ){ ?>
			   <option <?php if($item == $per_page){ echo 'selected="selected"'; } ?> value="<?php echo $item; ?>"><?php echo $item; ?></option>
        <?php } ?>
      </select>
	</p>
    
    <p>
	  <label for="<?php echo $this->get_field_id( 'page_id' ); ?>"><?php _e('Select Competition Page', 'wp-video-contest') ?></label>
      <select class="widefat" id="<?php echo $this->get_field_id( 'page_id' ); ?>" name="<?php echo $this->get_field_name( 'page_id' ); ?>">
         <?php
         $args = array(
                   'post_type' => 'page',
	                 'post_status' => 'publish'
         );
         $pages = get_pages( $args );
         foreach( $pages as $item ){ ?>
			   <option <?php if($item->ID == $page_id){ echo 'selected="selected"'; } ?> value="<?php echo $item->ID; ?>"><?php echo $item->post_title; ?></option>
        <?php } ?>
      </select>
		</p>
    
	<?php
	}


	 
}//End class
?>