<?php
/**
 *
 * @package   WP Video Contest
 * @author    Socialleadchiefteam
 * @link      http://www.socialleadchief.com/
 *
 * @wordpress-plugin
 * Plugin Name:       WP Video Contest
 * Plugin URI:        http://www.socialleadchief.com/
 * Description:       Thanks to WP Video Contest WordPress Plugin you can easily organize a WP Video Contest on your website.
 * Version:           1.1.0
 * Author:            Socialleadchiefteam
 * Author URI:        http://www.socialleadchief.com/
 * Text Domain:       wp-video-contest
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/*
 *  Reqire classes
 */
require_once( plugin_dir_path( __FILE__ ) . 'class-wp-video-contest.php' );
require_once( plugin_dir_path( __FILE__ ) . 'class-wp-video-contest-admin.php' );
require_once( plugin_dir_path( __FILE__ ) . 'widget-wp-video-contest.php' );

/*
 * Register hooks that are fired when the plugin is activated or deactivated.
 * When the plugin is deleted, the uninstall.php file is loaded.
 */
register_activation_hook( __FILE__, array( 'Video_Competition', 'activate' ) );
register_deactivation_hook( __FILE__, array( 'Video_Competition', 'deactivate' ) );

/*
 *  Load classes
 */
add_action( 'plugins_loaded', array( 'Video_Competition', 'get_instance' ) );
add_action( 'plugins_loaded', array( 'Video_Competition_Admin', 'get_instance' ) );

include('shortcodes/shortcodes.php');

function getVCompetitionViews($postID){
    $count_key = 'post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
        return "0";
    }
    return $count.'';
}
function setVCompetitionViews($postID) {
    $count_key = 'post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        $count = 0;
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
    }else{
        $count++;
        update_post_meta($postID, $count_key, $count);
    }
}

function remove_custom_video_shortcode($content) {
  if(isset($_GET['contest'])){
  
    if($_GET['contest']=='upload-video'){
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-upload-video]', $content);
    }
    elseif($_GET['contest']=='videos'){
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-videos]', $content);
    }
    elseif($_GET['contest']=='contest-condition'){
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-condition]', $content);
    }
    elseif($_GET['contest']=='video-detail'){
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-video-detail]', $content);
    }
	elseif($_GET['contest']=='contest-top10'){
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-top10]', $content);
	  
    }elseif($_GET['contest']=='contest-profile'){
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-profile]', $content);
    }else{
      return str_replace('[wp-video-contest-page]', '[wp-video-contest-videos]', $content);
    }
  
  }else{ 
    return str_replace('[wp-video-contest-page]', '[wp-video-contest-videos]', $content);
  }
  
  }
  add_filter( 'the_content', 'remove_custom_video_shortcode', 6);


  function contest_video_pagination( $range = 2, $paged, $items = 0, $limit = 20){  
     $out = '';
     //Dodělat vzorec
     $page_link = $_SERVER["REQUEST_URI"];
     $pag = explode('&paged',$page_link);
     if(count($pag>0)){
      $page_link = $pag[0]; 
     }
     
     if(!empty($_GET['paged'])){
      $paged = $_GET['paged'];
     }else{
      $paged = 1;
     }
     
     //$items = $this->slot_number();
     
     if($items == 0){
      $pages = 1;
     }else{
      $pages = ceil($items/$limit);
     }
     $showitems = ($range * 2)+1;  
 
         if(1 != $pages){
            $out .= '<div class="slot_pagination">';
         
         if($paged > 2 && $paged > $range+1 && $showitems < $pages){
            $out .= '<a href="'.$page_link.'" class="btn btn-info"> << </a>';
         } 
         if($paged > 1 && $showitems < $pages){
            $out .= '<a href="'.$page_link.'&paged='.($paged-1).'" class="btn btn-info"> < </a>';
         }
         
         for ($i=1; $i <= $pages; $i++){
             if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems )){
                 $out .= ($paged == $i)? '<span class="btn btn-current">'.$i.'</span>':'<a href="'.$page_link.'&paged='.$i.'" class="inactive btn btn-info">'.$i.'</a>';
             }
         }
 
         if ($paged < $pages && $showitems < $pages){ 
            $out .= '<a href="'.$page_link.'&paged='.($paged+1).'" class="btn btn-info"> > </a>';
         }  
         if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages){ 
         $out .= '<a href="'.$page_link.'&paged='.$pages.'" class="btn btn-info"> >> </a>'; 
        }
         
         
         $out .= '</div>';
     }
     
     return $out;
}

function wp_video_login_and_sigin_form( $args = array() ) {
	$defaults = array(
		'echo' => true,
		'redirect' => ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'], // Default redirect is back to the current page
		'form_id' => 'loginform',
		'label_username' => __('Username:','wp-video-contest'),
		'label_password' => __('Password:','wp-video-contest'),
		'label_remember' => __('Remember Me','wp-video-contest'),
		'label_log_in' => __('Log In','wp-video-contest'),
		'id_username' => 'user_login',
		'id_password' => 'user_pass',
		'id_remember' => 'rememberme',
		'id_submit' => 'wp-submit',
		'remember' => true,
		'value_username' => '',
		'value_remember' => false, // Set this to true to default the "Remember me" checkbox to checked
	);

	/**
	 * Filter the default login form output arguments.
	 *
	 * @since 1.0.0
	 *
	 * @see wp_login_form()
	 *
	 * @param array $defaults An array of default login form arguments.
	 */
	$args = wp_parse_args( $args, apply_filters( 'login_form_defaults', $defaults ) );

	/**
	 * Filter content to display at the top of the login form.
	 *
	 * The filter evaluates just following the opening form tag element.
	 *
	 * @since 1.0.0
	 *
	 * @param string $content Content to display. Default empty.
	 * @param array  $args    Array of login form arguments.
	 */
	$login_form_top = apply_filters( 'login_form_top', '', $args );

	/**
	 * Filter content to display in the middle of the login form.
	 *
	 * The filter evaluates just following the location where the 'login-password'
	 * field is displayed.
	 *
	 * @since 1.0.0
	 *
	 * @param string $content Content to display. Default empty.
	 * @param array  $args    Array of login form arguments.
	 */
	$login_form_middle = apply_filters( 'login_form_middle', '', $args );

	/**
	 * Filter content to display at the bottom of the login form.
	 *
	 * The filter evaluates just preceding the closing form tag element.
	 *
	 * @since 1.0.0
	 *
	 * @param string $content Content to display. Default empty.
	 * @param array  $args    Array of login form arguments.
	 */
	$login_form_bottom = apply_filters( 'login_form_bottom', '', $args );

	$form = '
		<form name="' . $args['form_id'] . '" id="' . $args['form_id'] . '" action="' . esc_url( site_url( 'wp-login.php', 'login_post' ) ) . '" method="post">
		   <h4>'.__('Log In','wp-video-contest').'</h4>
			' . $login_form_top . '
			<div><label for="' . esc_attr( $args['id_username'] ) . '"><strong>' . esc_html( $args['label_username'] ) . '</strong></label></div>
			<div class="wp_video_contest-input"><input type="text" name="log" id="' . esc_attr( $args['id_username'] ) . '" class="input" value="' . esc_attr( $args['value_username'] ) . '" size="20" /></div>
			<div><label for="' . esc_attr( $args['id_password'] ) . '"><strong>' . esc_html( $args['label_password'] ) . '</strong></label></div>
			<div class="wp_video_contest-input"><input type="password" name="pwd" id="' . esc_attr( $args['id_password'] ) . '" class="input" value="" size="20" /></div>
			' . $login_form_middle . '
			' . ( $args['remember'] ? '<div><label><input name="rememberme" type="checkbox" id="' . esc_attr( $args['id_remember'] ) . '" value="forever"' . ( $args['value_remember'] ? ' checked="checked"' : '' ) . ' /> ' . esc_html( $args['label_remember'] ) . '</label></div>' : '' ) . '
			<div class="wp_video_contest-input"><input type="submit" name="wp-submit" id="' . esc_attr( $args['id_submit'] ) . '" class="button-primary" value="' . esc_attr( $args['label_log_in'] ) . '" /></div>
			<div class="wp_video_contest-input"><input type="hidden" name="redirect_to" value="' . esc_url( $args['redirect'] ) . '" /></div>
			' . $login_form_bottom . '
		</form>';

	
		return $form;
}

function wp_video_contest_registration_form() {  
    $redirect = ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    $form ='
    <form name="registerform" action="' . esc_url( site_url( 'wp-login.php?action=register', 'login_post' ) ) . '" method="post" novalidate="novalidate">
	<h4>'.__('Registration Form','photo-contest').'</h4>
	<div><label for="user_login"><strong>'.__('Username').'</strong></label></div>
	<div class="wp_video_contest-input"><input type="text" name="user_login" id="user_login" class="input" value="" size="25" /></div>
	
	<div><label for="user_email"><strong>'.__('E-mail').'</strong></label></div>
	<div class="wp_video_contest-input"><input type="email" name="user_email" id="user_email" class="input" value="" size="25" /></div>
	<div><em>'.__('A password will be e-mailed to you.').'</em><div>
	<br class="clear" />
	<input type="hidden" name="redirect_to" value="'.$redirect.'&action=register_ok" />
	<div class="wp_video_contest-input"><input type="submit" name="wp-submit" id="wp-submit" class="button-primary" value="'.__('Register').'" /></div>
    </form>
    ';
	return $form;
}



/**
 *
 *  Register custom post type
 *  
 */  
 
add_action('init', 'wp_video_contest_tax_init');
function wp_video_contest_tax_init() {
	register_post_type(
		'wp_video_contest',
		array(
			'labels' => array(
				'name' => 'WP Video Contest',
				'singular_name' => 'WP Video Contest'
			),
			'public' => true,
			'has_archive' => true,
			'rewrite' => array('slug' => 'wp-video-contest'),
			'supports' => array('title', 'editor', 'thumbnail','comments','custom-fields','excerpt','author'),
			'can_export' => true,
		)
	);

	register_taxonomy('video_category', 'wp_video_contest', array('hierarchical' => true, 'label' => 'Categories', 'query_var' => true, 'rewrite' => true));

}



function wp_video_contest_get_video_id( $url ) {
               if( preg_match( '/http:\/\/youtu.be/', $url, $matches) ) {
                       $url = parse_url($url, PHP_URL_PATH);
                       $url = str_replace( '/', '',  $url);
                       return $url;

               } elseif ( preg_match( '/watch/', $url, $matches) ) {
                       $arr = parse_url($url);
                       $url = str_replace( 'v=', '', $arr['query'] );
                       return $url;

               } elseif ( preg_match( '/http:\/\/www.youtube.com\/v/', $url, $matches) ) {
                       $arr = parse_url($url);
                       $url = str_replace( '/v/', '', $arr['path'] );
                       return $url;

               } elseif ( preg_match( '/http:\/\/www.youtube.com\/embed/', $url, $matches) ) {
                       $arr = parse_url($url);
                       $url = str_replace( '/embed/', '', $arr['path'] );
                       return $url;

               } elseif ( preg_match("#(?<=v=)[a-zA-Z0-9-]+(?=&)|(?<=[0-9]/)[^&\n]+|(?<=v=)[^&\n]+#", $url, $matches) ) {
                       return $matches[0];

               } else {
                       return false;
               }
               
               
       }
       
function wp_video_contest_parse_youtube_id($url){

    if (strpos( $url,"v=") !== false){
        return substr($url, strpos($url, "v=") + 2, 11);
    }
    elseif(strpos( $url,"embed/") !== false)
    {
        return substr($url, strpos($url, "embed/") + 6, 11);
    }
        return false;
}       

?>